/*++ 

Module Name: 

OpcError.h 

Abstract: 

This file is generated by the MC tool from the OpcError.MC message 
file. 

Author: 

OPC Task Force 

Revision History: 

--*/ 

#ifndef __OPCERROR_H 
#define __OPCERROR_H 

// First the OPC Error class messages 
// 
//  Values are 32 bit values layed out as follows: 
// 
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1 
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 
//  +---+-+-+-----------------------+-------------------------------+ 
//  |Sev|C|R|     Facility          |               Code            | 
//  +---+-+-+-----------------------+-------------------------------+ 
// 
//  where 
// 
//      Sev - is the severity code 
// 
//          00 - Success 
//          01 - Informational 
//          10 - Warning 
//          11 - Error 
// 
//      C - is the Customer code flag 
// 
//      R - is a reserved bit 
// 
//      Facility - is the facility code 
// 
//      Code - is the facility's status code 
// 
// 
// Define the facility codes 
// 


// 
// Define the severity codes 
// 


// 
// MessageId: OPC_E_INVALIDHANDLE 
// 
// MessageText: 
// 
//  An invalid handle was passed 
// 
#define OPC_E_INVALIDHANDLE              ((HRESULT)0xC0040001L) 

// 
// MessageId: OPC_E_DUPLICATE 
// 
// MessageText: 
// 
//  A duplicate parameter was passed where one is not allowed 
// 
#define OPC_E_DUPLICATE                  ((HRESULT)0xC0040002L) 

// 
// MessageId: OPC_E_UNKNOWNLCID 
// 
// MessageText: 
// 
//  The server does not support the specified locale id 
// 
#define OPC_E_UNKNOWNLCID                ((HRESULT)0xC0040003L) 

// 
// MessageId: OPC_E_BADTYPE 
// 
// MessageText: 
// 
//  The server cannot convert between the passed or requested data type and the canonical type 
// 
#define OPC_E_BADTYPE                    ((HRESULT)0xC0040004L) 

// 
// MessageId: OPC_E_PUBLIC 
// 
// MessageText: 
// 
//  The requested operation cannot be done on a public group 
// 
#define OPC_E_PUBLIC                     ((HRESULT)0xC0040005L) 

// 
// MessageId: OPC_E_BADRIGHTS 
// 
// MessageText: 
// 
//  The item's AccessRights do not allow the operation 
// 
#define OPC_E_BADRIGHTS                  ((HRESULT)0xC0040006L) 

// 
// MessageId: OPC_E_UNKNOWNITEMID 
// 
// MessageText: 
// 
//  The item definition does not exist within the servers address space 
// 
#define OPC_E_UNKNOWNITEMID              ((HRESULT)0xC0040007L) 

// 
// MessageId: OPC_E_INVALIDITEMID 
// 
// MessageText: 
// 
//  The item definition does not comform to the server's syntax 
// 
#define OPC_E_INVALIDITEMID              ((HRESULT)0xC0040008L) 

// 
// MessageId: OPC_E_INVALIDFILTER 
// 
// MessageText: 
// 
//  The filter string is not valid 
// 
#define OPC_E_INVALIDFILTER              ((HRESULT)0xC0040009L) 

// 
// MessageId: OPC_E_UNKNOWNPATH 
// 
// MessageText: 
// 
//  The item's access path is not known to the server 
// 
#define OPC_E_UNKNOWNPATH                ((HRESULT)0xC004000AL) 

// 
// MessageId: OPC_E_RANGE 
// 
// MessageText: 
// 
//  The value passed to WRITE was out of range 
// 
#define OPC_E_RANGE                      ((HRESULT)0xC004000BL) 

// 
// MessageId: OPC_E_DUPLICATE_NAME 
// 
// MessageText: 
// 
//  A group with a duplicate name already exists in the server 
// 
#define OPC_E_DUPLICATE_NAME             ((HRESULT)0xC004000CL) 

// 
// MessageId: OPC_S_UNSUPPORTEDRATE 
// 
// MessageText: 
// 
//  The server does not support the requested rate, but will use the closest available 
// 
#define OPC_S_UNSUPPORTEDRATE            ((HRESULT)0x0004000DL) 

// 
// MessageId: OPC_S_CLAMP 
// 
// MessageText: 
// 
//  A value passed to WRITE was accepted, but was clamped 
// 
#define OPC_S_CLAMP                      ((HRESULT)0x0004000EL) 

// 
// MessageId: OPC_S_INUSE 
// 
// MessageText: 
// 
//  The operation cannot be completed because the object still has references that exist 
// 
#define OPC_S_INUSE                      ((HRESULT)0x0004000FL) 

// 
// MessageId: OPC_E_INVALIDCONFIGFILE 
// 
// MessageText: 
// 
//  The server's configuration file is an invalid format 
// 
#define OPC_E_INVALIDCONFIGFILE          ((HRESULT)0xC0040010L) 

// 
// MessageId: OPC_E_NOTFOUND 
// 
// MessageText: 
// 
//  The server could not locate the requested object 
// 
#define OPC_E_NOTFOUND                   ((HRESULT)0xC0040011L) 

// 
// MessageId: OPC_E_INVALID_PID 
// 
// MessageText: 
// 
//  The server does not recognise the passed property ID 
// 
#define OPC_E_INVALID_PID                ((HRESULT)0xC0040012L) 

#endif // OpcError 